# DeclarationManagement Class Reference

`#include <DeclarationManagement.hh>`

List of all members.

## Public Member Functions
| DeclarationManagement (Communications *, FederationManagement *, RootObject *)
| DeclarationManagement.
| ~DeclarationManagement ()
void | publishObjectClass (ObjectClassHandle theClassHandle, std::vector< AttributeHandle > &attribArray, UShort attribArraySize, TypeException &e)
void | unpublishObjectClass (ObjectClassHandle theClassHandle, TypeException &e)
void | publishInteractionClass (InteractionClassHandle theInteractionHandle, TypeException &e)
void | unpublishInteractionClass (InteractionClassHandle theInteractionHandle, TypeException &e)
void | subscribeObjectClassAttribute (ObjectClassHandle theClassHandle, std::vector< AttributeHandle > &attribArray, UShort attribArraySize, TypeException &e)
void | unsubscribeObjectClassAttribute (ObjectClassHandle theClassHandle, TypeException &e)
void | subscribeInteractionClass (InteractionClassHandle theClassHandle, TypeException &e)
void | unsubscribeInteractionClass (InteractionClassHandle theClassHandle, TypeException &e)
void | setClassRelevanceAdvisorySwitch (bool state, TypeException &e)
| Transmits the Networkmessage NM_Set_Class_Relevance_Advisory_Switch to RTIG.
void | startRegistrationForObjectClass (ObjectClassHandle theClass, TypeException &e)
void | stopRegistrationForObjectClass (ObjectClassHandle theClass, TypeException &e)
void | setInteractionRelevanceAdvisorySwitch (bool state, TypeException &e)
| Transmits the Networkmessage NM_Set_Interaction_Relevance_Advisory_Switch to RTIG.
void | turnInteractionsOn (InteractionClassHandle theHandle, TypeException &e)
void | turnInteractionsOff (InteractionClassHandle theHandle, TypeException &e)
## Protected Attributes
Communications * | comm
Queues * | queues
FederationManagement * | fm
RootObject * | rootObject

## Detailed Description

Definition at line 43 of file DeclarationManagement.hh.

## Constructor & Destructor Documentation

DeclarationManagement | ( | Communications * | GC,
|  | FederationManagement * | GF,
|  | RootObject * | theRootObj |
| ) |  |  |

DeclarationManagement.

Definition at line 50 of file DeclarationManagement.cc.

References DeclarationManagement::comm, DeclarationManagement::fm, and DeclarationManagement::rootObject.

~DeclarationManagement | ( |  | ) |

Definition at line 61 of file DeclarationManagement.cc.

## Member Function Documentation

void publishObjectClass | ( | ObjectClassHandle | theClassHandle,
|  | std::vector< AttributeHandle > & | attribArray,
|  | UShort | attribArraySize,
|  | TypeException & | e |
| ) |  |  |

Definition at line 68 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::rtia::D, certi::e_NO_EXCEPTION, NetworkMessage::federate, FederationManagement::federate, NetworkMessage::federation, DeclarationManagement::fm, certi::rtia::G, NetworkMessage::handleArray, NetworkMessage::handleArraySize, NetworkMessage::objectClass, RootObject::ObjectClasses, PrettyDebug::Out(), pdExcept, pdGendoc, ObjectClassSet::publish(), NetworkMessage::PUBLISH_OBJECT_CLASS, DeclarationManagement::rootObject, Communications::sendMessage(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void unpublishObjectClass | ( | ObjectClassHandle | theClassHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 115 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::rtia::D, certi::e_NO_EXCEPTION, NetworkMessage::federate, FederationManagement::federate, NetworkMessage::federation, DeclarationManagement::fm, NetworkMessage::objectClass, RootObject::ObjectClasses, PrettyDebug::Out(), pdExcept, ObjectClassSet::publish(), DeclarationManagement::rootObject, Communications::sendMessage(), NetworkMessage::UNPUBLISH_OBJECT_CLASS, and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void publishInteractionClass | ( | InteractionClassHandle | theInteractionHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 159 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::rtia::D, certi::e_NO_EXCEPTION, NetworkMessage::federate, FederationManagement::federate, NetworkMessage::federation, DeclarationManagement::fm, NetworkMessage::interactionClass, RootObject::Interactions, PrettyDebug::Out(), pdExcept, InteractionSet::publish(), NetworkMessage::PUBLISH_INTERACTION_CLASS, DeclarationManagement::rootObject, Communications::sendMessage(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void unpublishInteractionClass | ( | InteractionClassHandle | theInteractionHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 191 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::rtia::D, certi::e_NO_EXCEPTION, NetworkMessage::federate, FederationManagement::federate, NetworkMessage::federation, DeclarationManagement::fm, NetworkMessage::interactionClass, RootObject::Interactions, PrettyDebug::Out(), pdExcept, InteractionSet::publish(), DeclarationManagement::rootObject, Communications::sendMessage(), NetworkMessage::UNPUBLISH_INTERACTION_CLASS, and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void subscribeObjectClassAttribute | ( | ObjectClassHandle | theClassHandle,
|  | std::vector< AttributeHandle > & | attribArray,
|  | UShort | attribArraySize,
|  | TypeException & | e |
| ) |  |  |

Definition at line 224 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DeclarationManagement::fm, certi::rtia::G, NetworkMessage::handleArray, NetworkMessage::handleArraySize, NetworkMessage::objectClass, PrettyDebug::Out(), pdGendoc, Communications::sendMessage(), NetworkMessage::SUBSCRIBE_OBJECT_CLASS, and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void unsubscribeObjectClassAttribute | ( | ObjectClassHandle | theClassHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 263 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::e_NO_EXCEPTION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DeclarationManagement::fm, NetworkMessage::objectClass, Communications::sendMessage(), NetworkMessage::UNSUBSCRIBE_OBJECT_CLASS, and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void subscribeInteractionClass | ( | InteractionClassHandle | theClassHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 290 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::rtia::D, certi::e_NO_EXCEPTION, NetworkMessage::federate, FederationManagement::federate, NetworkMessage::federation, DeclarationManagement::fm, NetworkMessage::interactionClass, RootObject::Interactions, PrettyDebug::Out(), pdExcept, DeclarationManagement::rootObject, Communications::sendMessage(), InteractionSet::subscribe(), NetworkMessage::SUBSCRIBE_INTERACTION_CLASS, and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void unsubscribeInteractionClass | ( | InteractionClassHandle | theClassHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 326 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::rtia::D, certi::e_NO_EXCEPTION, NetworkMessage::federate, FederationManagement::federate, NetworkMessage::federation, DeclarationManagement::fm, NetworkMessage::interactionClass, RootObject::Interactions, PrettyDebug::Out(), pdExcept, DeclarationManagement::rootObject, Communications::sendMessage(), InteractionSet::subscribe(), NetworkMessage::UNSUBSCRIBE_INTERACTION_CLASS, and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void setClassRelevanceAdvisorySwitch | ( | bool | state,
|  | TypeException & | e |
| ) |  |  |

Transmits the Networkmessage NM_Set_Class_Relevance_Advisory_Switch to RTIG.

The transmission sets the ClassRelevanceAdvisory switch at RTIG side to the value of the input parameter state. The invocation is caused by a successfull transmission of the message ENABLE_CLASS_RELEVANCE_ADVISORY_SWITCH from the federate to RTIA.

Parameters:

  `[in]` | state | is the new value for the switch, true means enable, false means disable
  `[in,out]` | e | is a reference to a possible exception

Definition at line 361 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, NM_Set_Class_Relevance_Advisory_Switch::classRelevanceAdvisorySwitchOff(), NM_Set_Class_Relevance_Advisory_Switch::classRelevanceAdvisorySwitchOn(), DeclarationManagement::comm, certi::e_NO_EXCEPTION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DeclarationManagement::fm, certi::rtia::G, PrettyDebug::Out(), pdGendoc, and Communications::sendMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void startRegistrationForObjectClass | ( | ObjectClassHandle | theClass,
|  | TypeException & | e |
| ) |  |  |

Definition at line 387 of file DeclarationManagement.cc.

References DeclarationManagement::comm, certi::rtia::G, PrettyDebug::Out(), pdGendoc, Communications::requestFederateService(), Message::setObjectClass(), Message::START_REGISTRATION_FOR_OBJECT_CLASS, and Message::type.

Referenced by TimeManagement::executeFederateService().

Here is the call graph for this function:

void stopRegistrationForObjectClass | ( | ObjectClassHandle | theClass,
|  | TypeException & | e |
| ) |  |  |

Definition at line 406 of file DeclarationManagement.cc.

References DeclarationManagement::comm, certi::rtia::D, Message::getExceptionType(), PrettyDebug::Out(), pdExcept, Communications::receiveUN(), Communications::sendUN(), Message::setObjectClass(), Message::STOP_REGISTRATION_FOR_OBJECT_CLASS, and Message::type.

Here is the call graph for this function:

void setInteractionRelevanceAdvisorySwitch | ( | bool | state,
|  | TypeException & | e |
| ) |  |  |

Transmits the Networkmessage NM_Set_Interaction_Relevance_Advisory_Switch to RTIG.

The transmission sets the InteractionRelevanceAdvisory switch at RTIG side to the value of the input parameter state. The invocation is caused by a successfull transmission of the message ENABLE_INTERACTION_RELEVANCE_ADVISORY_SWITCH from the federate to RTIA.

Parameters:

  `[in]` | state | is the new value for the switch, true means enable, false means disable
  `[in,out]` | e | is a reference to a possible exception

Definition at line 433 of file DeclarationManagement.cc.

References FederationManagement::_numero_federation, DeclarationManagement::comm, certi::e_NO_EXCEPTION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DeclarationManagement::fm, certi::rtia::G, NM_Set_Interaction_Relevance_Advisory_Switch::interactionRelevanceAdvisorySwitchOff(), NM_Set_Interaction_Relevance_Advisory_Switch::interactionRelevanceAdvisorySwitchOn(), PrettyDebug::Out(), pdGendoc, and Communications::sendMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void turnInteractionsOn | ( | InteractionClassHandle | theHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 459 of file DeclarationManagement.cc.

References DeclarationManagement::comm, certi::rtia::D, Message::getExceptionType(), PrettyDebug::Out(), pdExcept, Communications::receiveUN(), Communications::sendUN(), Message::setInteractionClass(), Message::TURN_INTERACTIONS_ON, and Message::type.

Here is the call graph for this function:

void turnInteractionsOff | ( | InteractionClassHandle | theHandle,
|  | TypeException & | e |
| ) |  |  |

Definition at line 481 of file DeclarationManagement.cc.

References DeclarationManagement::comm, certi::rtia::D, Message::getExceptionType(), PrettyDebug::Out(), pdExcept, Communications::receiveUN(), Communications::sendUN(), Message::setInteractionClass(), Message::TURN_INTERACTIONS_OFF, and Message::type.

Here is the call graph for this function:

## Member Data Documentation

Communications* comm`[protected]`

Definition at line 120 of file DeclarationManagement.hh.

Referenced by DeclarationManagement::DeclarationManagement(), DeclarationManagement::publishInteractionClass(), DeclarationManagement::publishObjectClass(), DeclarationManagement::setClassRelevanceAdvisorySwitch(), DeclarationManagement::setInteractionRelevanceAdvisorySwitch(), DeclarationManagement::startRegistrationForObjectClass(), DeclarationManagement::stopRegistrationForObjectClass(), DeclarationManagement::subscribeInteractionClass(), DeclarationManagement::subscribeObjectClassAttribute(), DeclarationManagement::turnInteractionsOff(), DeclarationManagement::turnInteractionsOn(), DeclarationManagement::unpublishInteractionClass(), DeclarationManagement::unpublishObjectClass(), DeclarationManagement::unsubscribeInteractionClass(), and DeclarationManagement::unsubscribeObjectClassAttribute().

Queues* queues`[protected]`

Definition at line 121 of file DeclarationManagement.hh.

FederationManagement* fm`[protected]`

Definition at line 122 of file DeclarationManagement.hh.

Referenced by DeclarationManagement::DeclarationManagement(), DeclarationManagement::publishInteractionClass(), DeclarationManagement::publishObjectClass(), DeclarationManagement::setClassRelevanceAdvisorySwitch(), DeclarationManagement::setInteractionRelevanceAdvisorySwitch(), DeclarationManagement::subscribeInteractionClass(), DeclarationManagement::subscribeObjectClassAttribute(), DeclarationManagement::unpublishInteractionClass(), DeclarationManagement::unpublishObjectClass(), DeclarationManagement::unsubscribeInteractionClass(), and DeclarationManagement::unsubscribeObjectClassAttribute().

RootObject* rootObject`[protected]`

Definition at line 123 of file DeclarationManagement.hh.

Referenced by DeclarationManagement::DeclarationManagement(), DeclarationManagement::publishInteractionClass(), DeclarationManagement::publishObjectClass(), DeclarationManagement::subscribeInteractionClass(), DeclarationManagement::unpublishInteractionClass(), DeclarationManagement::unpublishObjectClass(), and DeclarationManagement::unsubscribeInteractionClass().

The documentation for this class was generated from the following files:

- DeclarationManagement.hh
- DeclarationManagement.cc